﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Infragistics.Windows.DockManager.Events;
using Infragistics.Windows.DockManager;

namespace DockManagerContentPaneCommand
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void ContentPane_OptionsMenuOpening(object sender, PaneOptionsMenuOpeningEventArgs e)
        {
            ContentPane cp = e.OriginalSource as ContentPane;

            if (e.Items.Count > 0)
            {
                Separator sep = new Separator();
                sep.SetResourceReference(Separator.StyleProperty, XamDockManager.MenuItemSeparatorStyleKey);
                e.Items.Add(sep);
            }

            // the OptionsMenuOpening event is raised when you right click on a
            // pane's caption or tab item as well as when you click the window
            // position menu item in the caption and allows you to add/remove
            // items from the menu.
            MenuItem mi = new MenuItem();
            mi.Command = ApplicationCommands.Save;

            // to have the menu items use the same styling as the default
            // menu items, we'll associate it with the same style that
            // the dockmanager uses for its menu items
            mi.SetResourceReference(MenuItem.StyleProperty, XamDockManager.MenuItemStyleKey);

            e.Items.Add(mi);
        }

        private void CommandBinding_CanExecute(object sender, CanExecuteRoutedEventArgs e)
        {
            // for the purposes of this demonstration, the save command
            // associated with the binding that raises this event is always
            // enabled
            e.CanExecute = true;
            e.Handled = true;
        }

        private void CommandBinding_Executed(object sender, ExecutedRoutedEventArgs e)
        {
            // implement save functionality here
            Microsoft.Win32.SaveFileDialog dlg = new Microsoft.Win32.SaveFileDialog();
            dlg.ShowDialog();
        }
    }
}
